#ifndef POLYNOMIAL_1D_ROOT_COMPUTER_HPP
#define POLYNOMIAL_1D_ROOT_COMPUTER_HPP

#include <analysis/SturmSequence.hpp>

#include <optional>

class Polynomial1DRootComputer
{
 private:
  struct PositionSignChanges
  {
    double position;
    size_t nb_sign_changes;
  };

  const SturmSequence m_sturm_sequence;
  const double m_left;
  const double m_right;

  double _computeRootBetween(const PositionSignChanges& l, const PositionSignChanges& r) const;

 public:
  std::optional<double> getFirstRoot() const;

  Polynomial1DRootComputer(const Polynomial1D& p, const double a, const double b);

  ~Polynomial1DRootComputer() = default;
};

#endif   // POLYNOMIAL_1D_ROOT_COMPUTER_HPP
