#include <catch2/catch_approx.hpp>
#include <catch2/catch_test_macros.hpp>

#include <analysis/SturmSequence.hpp>

// clazy:excludeall=non-pod-global-static

TEST_CASE("SturmSequence", "[analysis]")
{
  Polynomial1D p({-1, -1, 0, 1, 1});

  SturmSequence sturm_sequence(p);

  REQUIRE(sturm_sequence.size() == 5);

  REQUIRE(sturm_sequence.numberOfSignChanges(-10) == 3);
  REQUIRE(sturm_sequence.numberOfSignChanges(10) == 1);
}
